// Monique Tetreault
// CS 113 Fall 2007

import ucigame.*;

public class MiniGame extends Ucigame
{
	Sprite start;
    Sprite rei;
    Sprite reiS;
    Sprite reiL;
    Sprite reiR;
    Sprite ball;
    Sprite floor1;
    Sprite floor2;
    Sprite floor3;
    Sprite floor4;
    Sprite floor5;
    Sprite stone;
    Sprite goal;
    Sprite fin;
    Sound song;

    public void setup()
    {
        window.size(500, 500);
        window.title("MiniGame");
        window.showFPS();
        canvas.background(0, 255, 0);

        start = makeSprite(getImage("images/MiniGameStart.jpg"));
        reiS = makeSprite(getImage("images/ReiS.gif", 255, 255, 255));
        reiR = makeSprite(getImage("images/ReiR.gif", 255, 255, 255));
        reiL = makeSprite(getImage("images/ReiL.gif", 255, 255, 255));
        rei = reiS;
		rei.pin(reiS, 0, 0);
		rei.pin(reiL, 0, 0);
		rei.pin(reiR, 0, 0);
		reiS.show();
		reiR.hide();
		reiL.hide();
        ball = makeSprite(getImage("images/Sphere.gif", 255, 255, 255));
        ball.position(51, 0);
        ball.framerate(100);
        stone = makeSprite(getImage("images/rock.gif", 0, 0, 0));
        stone.position(51, 400);
        stone.framerate(100);
        floor1 = makeSprite(getImage("images/brick.jpg"), 300, 50);
        floor1.position(0, 52);
        floor2 = makeSprite(getImage("images/brick.jpg"), 300, 50);
        floor2.position(200, 225);
        floor3 = makeSprite(getImage("images/brick.jpg"), 125, 50);
        floor3.position(0, 450);
        floor4 = makeSprite(getImage("images/brick.jpg"), 245, 50);
        floor4.position(200, 450);
        floor5 = makeSprite(getImage("images/brick.jpg"), 75, 50);
        floor5.position(125, 450);
        goal = makeSprite(getImage("images/Goal.gif", 0, 0, 255));
        goal.position(450, 450);
        fin = makeSprite(getImage("images/fin.jpg"));

        song = getSound("Songs/LaserDance.mp3");
        song.loop();

        framerate(100);
    }

    public void draw()
    {
        canvas.clear();

        ball.nextY(ball.y() + 5);
        stone.nextY(stone.y() + 5);

        floor5.hide();

        ball.checkIfCollidesWith(rei);
        if(ball.collided(LEFT))
        {
			ball.nextX(rei.x() + 1);
			ball.nextY(ball.y());
		}
		if(ball.collided(RIGHT, TOP))
		{
			ball.nextX(ball.x() - ((rei.x() - ball.x()) / 10));
			ball.nextY(ball.y());
		}

		stone.checkIfCollidesWith(rei);
		if(stone.collided(LEFT))
		{
			stone.nextX(rei.x() + 1);
			stone.nextY(stone.y());
		}
		if(stone.collided(RIGHT, TOP))
		{
			stone.nextX(stone.x() - ((rei.x() - stone.x()) / 10));
			stone.nextY(stone.y());
		}

		stone.checkIfCollidesWith(BOTTOMEDGE);
		if(stone.collided())
		{
			ball.pauseIfCollidesWith(floor5, PIXELPERFECT);
		}

		if(ball.x() >= 444 && ball.y() >= 449)	///END GAME
		{
			fin.show();
		}

        rei.stopIfCollidesWith(TOPEDGE, BOTTOMEDGE, LEFTEDGE, RIGHTEDGE);
        rei.stopIfCollidesWith(floor1, floor2, floor3, floor4, PIXELPERFECT);
        ball.stopIfCollidesWith(BOTTOMEDGE, LEFTEDGE, RIGHTEDGE);
        ball.pauseIfCollidesWith(floor1, floor2, floor3, floor4, PIXELPERFECT);
        stone.pauseIfCollidesWith(LEFTEDGE, RIGHTEDGE, BOTTOMEDGE);
        stone.pauseIfCollidesWith(floor3, floor4, PIXELPERFECT);

        rei.draw();
        ball.draw();
        stone.draw();
        floor1.draw();
        floor2.draw();
        floor3.draw();
        floor4.draw();
        floor5.draw();
        goal.draw();
        fin.draw();		// must be first
        fin.hide();
        start.draw();	// must be last
    }

    public void onKeyPress()
	{
		/*	Up arrow key and W => move Rei up
			Down arrow key and S => move Rei down
			Left arrow key and A => move Rei left
			Right arrow key and D => move Rei right
			R => restart from beginning
			Spacebar => from start menu, begin level 1
			1 => start from beginning of level 1
			M => play music
			N => stop music
		*/

		Sprite prevRei;
	    // Arrow keys and WASD keys move the character
	    if (keyboard.isDown(keyboard.UP, keyboard.W))
	    {
			prevRei = rei;
			rei = reiS;
			reiS.show();
			reiL.hide();
			reiR.hide();
	        rei.nextY(prevRei.y() - 2);
	        rei.nextX(prevRei.x());
		}
	    else if (keyboard.isDown(keyboard.DOWN, keyboard.S))
	    {
			prevRei = rei;
			rei = reiS;
			reiS.show();
			reiL.hide();
			reiR.hide();
	        rei.nextY(prevRei.y() + 2);
	        rei.nextX(prevRei.x());
		}
	    else if (keyboard.isDown(keyboard.LEFT, keyboard.A))
	    {
			prevRei = rei;
			rei = reiL;
			reiL.show();
			reiS.hide();
			reiR.hide();
	        rei.nextX(prevRei.x() - 2);
	        rei.nextY(prevRei.y());
		}
	    else if (keyboard.isDown(keyboard.RIGHT, keyboard.D))
	    {
			prevRei = rei;
			rei = reiR;
			reiR.show();
			reiS.hide();
			reiL.hide();
	        rei.nextX(prevRei.x() + 2);
	        rei.nextY(prevRei.y());
		}
	    if (keyboard.isDown(keyboard.R))
	    {
			song.stop();
	    	setup();
		}
		if(keyboard.isDown(keyboard.SPACE))
		{
			start.hide();
		}
		if(keyboard.isDown(keyboard.K1))
		{
			song.stop();
			setup();
			start.hide();
		}
	    if (keyboard.key() == keyboard.M)
	    {
	    	song.play();
		}
		if(keyboard.key() == keyboard.N)
		{
			song.stop();
		}
    }
}
